Package: fAsianOptions
Title: Rmetrics - EBM and Asian Option Valuation
Date: 2017-11-12
Version: 3042.82
Author: Diethelm Wuertz [aut],
	Tobias Setz [cre]
Maintainer: Tobias Setz <tobias.setz@live.com>
Description: Provides functions for pricing
	and valuating Asian Options together with tools for analyzing
    and modeling Exponential Brownian Motion (EBM).
Depends: R (>= 2.15.1), timeDate, timeSeries, fBasics, fOptions
Imports: stats
Suggests: methods, RUnit
LazyData: yes
License: GPL (>= 2)
URL: http://www.rmetrics.org
NeedsCompilation: yes
Packaged: 2017-11-17 07:23:59 UTC; Tobias Setz
Repository: CRAN
Date/Publication: 2017-11-17 12:09:14 UTC
Built: R 4.5.2; i486--netbsdelf; 2026-02-20 21:25:02 UTC; unix

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:           EBM DENSITY APPROXIMATIONS:
#  dlognorm            log-Normal density an derivatives
#  plognorm            log-Normal, synonyme for plnorm
#  dgam                Gamma density, synonyme for dgamma
#  pgam                Gamma probability, synonyme for pgamma
#  drgam               Reciprocal-Gamma density
#  prgam               Reciprocal-Gamma probability
#  djohnson            Johnson Type I density
#  pjohnson            Johnson Type I probability
# FUNCTION :          MOMENTS FOR EBM DENSITY APPROXIMATIONS:
#  mnorm               Moments of Normal density
#  mlognorm            Moments of log-Normal density
#  mrgam               Moments of reciprocal-Gamma density
#  masian              Moments of Asian Option density
#  .DufresneMoments     Internal Function used by masian()
# FUNCTION:           NUMERICAL DERIVATIVES:
#  derivative          First and second numerical derivative
# FUNCTION:           ASIAN DENSITY:
#  d2EBM               Double Integrated EBM density
#  .thetaEBM            Internal Function used to compute *2EBM()
#  .psiEBM              Internal Function used to compute *2EBM()
#  dEBM                Exponential Brownian motion density
#  pEBM                Exponential Brownian motion probability              
#  .gxuEBM              Internal Function used to compute *EBM()
#  .gxtEBM              Internal Function used to compute *EBM()
#  .gxtuEBM             Internal Function used to compute *EBM()
#  dasymEBM            Exponential Brownian motion asymptotic density
################################################################################


test.lognorm = 
function()
{
    # dlognorm - log-Normal density an derivatives
    # plognorm - log-Normal, synonyme for plnorm

    # Calculate Log-Normal Density and its Derivatives:
    x = exp(seq(-2.8, 1.2, length = 100))
    y0 = dlognorm(x, deriv = 0)
    y1 = dlognorm(x, deriv = 1)
    y2 = dlognorm(x, deriv = 2) 
    
    # Compare with Numerical Differentiation:
    par(mfrow = c(2, 2))
    xa = exp(seq(-2.5, 1.5, length = 20))
    plot(x, y0, type = "l", main = "Log-Normal Density")
    plot(x, y1, type = "l", main = "1st Derivative")
    z = derivative(xa, dlognorm(xa, deriv = 0), deriv = 1)
    points(z$x, z$y, col = "steelblue")
    plot(x, y2, type = "l", main = "2nd Derivative")
    z = derivative(xa, dlognorm(xa, deriv = 0), deriv = 2)
    points(z$x, z$y, col = "steelblue")
    
    # Return Value:
    return()    
}
   

# ------------------------------------------------------------------------------


test.gam =
function()
{
    #  dgam - Gamma density, synonyme for dgamma
    #  pgam - Gamma probability, synonyme for pgamma

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.rgam = 
function()
{    
    # drgam - Reciprocal-Gamma density
    # prgam - Reciprocal-Gamma probability

    # Calculate Reciprocal-Gamma Density and its Derivaties:
    alpha = 2; beta = 1
    x = exp(seq(-2.8, 1.2, length = 100))
    y0 = drgam(x, alpha, beta, deriv = 0)
    y1 = drgam(x, alpha, beta, deriv = 1)
    y2 = drgam(x, alpha, beta, deriv = 2)
    
    # Compare with Numerical Differentiation:
    par(mfrow = c(2, 2))
    xa = exp(seq(-2.5, 1.5, length = 20))
    plot(x, y0, type = "l", main = "Rec-Gamma Density")
    plot(x, y1, type = "l", main = "1st Derivative")
    z = derivative(xa, drgam(xa, alpha, beta, deriv = 0), deriv = 1)
    points(z$x, z$y, col = "steelblue")
    plot(x, y2, type = "l", main = "2nd Derivative")
    z = derivative(xa, drgam(xa, alpha, beta, deriv = 0), deriv = 2)
    points(z$x, z$y, col = "steelblue")
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.johnson = 
function()
{        
    # djohnson - Johnson Type I density
    # pjohnson - Johnson Type I probability

    # Calculate Johnson-Type-I Density and its Derivaties:
    a = 0.3; b = 1.2; c = -0.2; d = 0.8
    x = exp(seq(-2.8, 1.2, length = 100))
    y0 = djohnson(x, a, b, c, d, deriv = 0)
    y1 = djohnson(x, a, b, c, d, deriv = 1)
    y2 = djohnson(x, a, b, c, d, deriv = 2)
    
    # Compare with Numerical Differentiation:
    par(mfrow = c(2, 2))
    xa = exp(seq(-2.5, 1.5, length = 20))
    plot(x, y0, type = "l", main = "Johnson Type I Density")
    plot(x, y1, type = "l", main = "1st Derivative")
    z = derivative(xa, djohnson(xa, a, b, c, d, deriv = 0), deriv = 1)
    points(z$x, z$y, col = "steelblue")
    plot(x, y2, type = "l", main = "2nd Derivative")
    z = derivative(xa, djohnson(xa, a, b, c, d, deriv = 0), deriv = 2)
    points(z$x, z$y, col = "steelblue")

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.moments = 
function()
{  
    # mnorm - Moments of Normal density
    # mlognorm - Moments of log-Normal density
    # mrgam - Moments of reciprocal-Gamma density
    # masian - Moments of Asian Option density
    # .DufresneMoments - Internal Function used by masian()

    # mnorm(mean = 0, sd = 1)
    mnorm()
    
    # mlognorm(meanlog = 0, sdlog = 1)
    mlognorm()
    
    # mrgam(alpha = 1/2, beta = 1)
    mrgam()                                                              # CHECK                                   
    
    # mjohnson(a, b, c, d)
    a = 0.3; b = 1.2; c = -0.2; d = 0.8
    mjohnson(a, b, c, d)                                                 # CHECK
    
    # masian(Time = 1, r = 0.045, sigma = 0.3) 
    masian()
    
    # .DufresneMoments(M = 4, Time = 1, r = 0.045, sigma = 0.30)
    .DufresneMoments(M = 12, Time = 1, r = 0.045, sigma = 0.30)
    
    # Return Value:
    return()    
}

    
# ------------------------------------------------------------------------------


test.d2EBM = 
function()
{  
    # d2EBM - Double Integrated EBM density
    # .thetaEBM - Internal Function used to compute *2EBM()
    # .psiEBM - Internal Function used to compute *2EBM()

    #  d2EBM(u, t = 1) 
    x = c(0.1, 0.5, 1, 2)
    
    # Density:
    d2 = d2EBM(u = x)
    d2
     
    # Compare with:
    d = dEBM(u = x)
    d
    
    # Print
    cbind(d2, d, difference = abs(d2-d))
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.dEBM = 
function()
{  
    #  dEBM - Exponential Brownian motion density
    #  pEBM - Exponential Brownian motion probability              
    #  .gxuEBM - Internal Function used to compute *EBM()
    #  .gxtEBM - Internal Function used to compute *EBM()
    #  .gxtuEBM - Internal Function used to compute *EBM()
    
    # Density:
    x = c(
        seq(-1.0, 0.0, length = 5), 
        seq( 0.0, 0.5, length = 20), 
        seq( 0.5, 5.0, length = 20))
    x = unique(sort(x))
    d = dEBM(u = x)
    print(d)
    par(mfrow = c(1,1))
    plot(x, y = d, type = "b", pch = 19, cex = 0.7)
    
    # Probability:
    x = c(-1, -0.5, 0, 0.1, 0.2, 0.5, 0.75, seq(1, 5, by = 0.5))
    p = pEBM(u = x)                          
    print(p)
    par(mfrow = c(1,1))
    plot(x, y = p, type = "b", pch = 19, cex = 0.7)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.dasymEBM = 
function()
{  
    # dasymEBM - Exponential Brownian motion asymptotic density
     
    # Density:
    x = c(
        seq(0.50, 1.10, length = 21),
        seq(1.10, 1.40, length = 21),
        seq(1.40, 5.00, length = 31))
    d = dasymEBM(u = x)
    print(d)
    par(mfrow = c(1,1))
    plot(x, y = d, type = "b", pch = 19, cex = 0.7)
    abline(h =0, lty = 3, col = "grey")
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


if (FALSE) {
    require(RUnit)
    testResult <- runTestFile("C:/Rmetrics/SVN/trunk/fOptions/tests/runit3A.R",
        rngKind = "Marsaglia-Multicarry", rngNormalKind = "Inversion")
    printTextProtocol(testResult)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# MOMENT MATCHING:                   DESCRIPTION:
#  MomentMatchedAsianOption           Valuate moment matched option prices
#  .LevyTurnbullWakemanAsianOption     Log-Normal Approximation
#  .MilevskyPosnerAsianOption          Reciprocal-Gamma Approximation
#  .PosnerMilevskyAsianOption          Johnson Type I Approximation
#  MomentMatchedAsianDensity          Valuate moment matched option densities
#  .LevyTurnbullWakemanAsianDensity    Log-Normal Approximation
#  .MilevskyPosnerAsianDensity         Reciprocal-Gamma Approximation
#  .PosnerMilevskyAsianDensity         Johnson Type I Approximation 
# GRAM CHARLIER SERIES EXPANSION:    DESCRIPTION:
#  GramCharlierAsianOption            Calculate Gram-Charlier option prices
#  .GramCharlierAsianDensity          NA
# STATE SPACE MOMENTS:               DESCRIPTION:
#  AsianOptionMoments                 Methods to calculate Asian Moments
#  .DufresneAsianOptionMoments         Moments from Dufresne's Formula
#  .AbrahamsonAsianOptionMoments       Moments from Abrahamson's Formula
#  .TurnbullWakemanAsianOptionMoments  First 2 Moments from Turnbull-Wakeman
#  .TolmatzAsianOptionMoments          Asymptotic Behavior after Tolmatz
# STATE SPACE DENSITIES:              DESCRIPTION:
#  StateSpaceAsianDensity              NA
#  .Schroeder1AsianDensity             NA
#  .Schroeder2AsianDensity             NA
#  .Yor1AsianDensity                   NA
#  .Yor2AsianDensity                   NA
#  .TolmatzAsianDensity                NA
#  .TolmatzAsianProbability            NA
# PARTIAL DIFFERENTIAL EQUATIONS:     DESCRIPTION:
#  PDEAsianOption                      PDE Asian Option Pricing
#   .ZhangAsianOption                   Asian option price by Zhang's 1D PDE
#    ZhangApproximateAsianOption
#   .VecerAsianOption                   Asian option price by Vecer's 1D PDE 
# LAPLACE INVERSION:                  DESCRIPTION:
#   GemanYorAsianOption                Asian option price by Laplace Inversion
#   gGemanYor                          Function to be Laplace inverted
# SPECTRAL EXPANSION:                 DESCRIPTION:
#   LinetzkyAsianOption                Asian option price by Spectral Expansion
#   gLinetzky                          Function to be integrated
# BOUNDS ON OPTION PRICES:            DESCRIPTION:
#   BoundsOnAsianOption                 Lower and upper bonds on Asian calls
#    CurranThompsonAsianOption          From Thompson's continuous limit
#    RogerShiThompsonAsianOption        From Thompson's single integral formula   
#    ThompsonAsianOption                Thompson's upper bound 
# SYMMETRY RELATIONS:                 DESCRIPTION:
#   CallPutParityAsianOption           Call-Put parity Relation
#   WithDividendsAsianOption           Adds dividends to Asian Option Formula
# TABULATED RESULTS:                  DESCRIPTION:
#   FuMadanWangTable                   Table from Fu, Madan and Wang's paper
#   FusaiTaglianiTable                 Table from Fusai und tagliani's paper
#   GemanTable                         Table from Geman's paper
#   LinetzkyTable                      Table from Linetzky's paper
#   ZhangTable                         Table from Zhang's paper
#   ZhangLongTable                     Long Table from Zhang's paper
#   ZhangShortTable                    Short Table from Zhang's paper
################################################################################


test.MomentMatchedAsianOption = 
function()
{
    # MomentMatchedAsianOption

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.MomentMatchedAsianDensity = 
function()
{
    # MomentMatchedAsianDensity  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.GramCharlierAsianOption = 
function()
{
    # GramCharlierAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.AsianOptionMoments = 
function()
{
    # AsianOptionMoments  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.StateSpaceAsianDensity = 
function()
{
    # StateSpaceAsianDensity  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.PDEAsianOption = 
function()
{
    # PDEAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.GemanYorAsianOption = 
function()
{
    # GemanYorAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.LinetzkyAsianOption = 
function()
{
    # LinetzkyAsianOption  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.BoundsOnAsianOption = 
function()
{    
    # BoundsOnAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.CurranThompsonAsianOption = 
function()
{
    # CurranThompsonAsianOption  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.RogerShiThompsonAsianOption = 
function()
{
    # RogerShiThompsonAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.ThompsonAsianOption = 
function()
{
    # ThompsonAsianOption
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.CallPutParityAsianOption = 
function()
{
    # CallPutParityAsianOption  

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.WithDividendsAsianOption = 
function()
{
    # WithDividendsAsianOption 

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.Table = 
function()
{ 
    # Table 

    # Return Value:
    return()    
}

    
# ------------------------------------------------------------------------------


if (FALSE) {
    require(RUnit)
    testResult <- runTestFile("C:/Rmetrics/SVN/trunk/fOptions/tests/runit3E.R",
        rngKind = "Marsaglia-Multicarry", rngNormalKind = "Inversion")
    printTextProtocol(testResult)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:                  DESCRIPTION:
#  BesselI                    Modified Bessel Function of first kind
#  BesselK                    Modified Bessel Function of third kind
#  BesselDI                   Derivative of BesselI
#  BesselDK                   Derivative of BesselK
# INTERNAL FUNCTION:         DESCRIPTION:
#  .BesselN                   For internal use only 
#  .Bessel01                   ...
#  .Bessel.MSTA1               ...
#  .Bessel.MSTA2               ...
#  .Bessel.ENVJ                ...
################################################################################


test.Bessel = 
function()
{
    # BesselI - Modified Bessel Function of first kind
    # BesselK - Modified Bessel Function of third kind

    # Modified Bessel Functions I and K, Abramowitz-Stegun, Chapter 9.6, p. 374
    
    # Abramowitz-Stegun, Figure 9.7, p. 374
    plot(x = c(0, 3), y = c(0, 2.5), type = "n", xlab = "x", 
        ylab = " I0  I1  K0  K1 ")
    grid()
    x = seq(0, 3, length = 301)
    lines(x, BesselI(x, 0))
    lines(x, BesselI(x, 1), lty = 3)
    lines(x, BesselK(x, 0))
    lines(x, BesselK(x, 1), lty = 3)
    
    # Abramowitz-Stegun, Figure 9.8, p. 375
    plot(x = c(0, 10), y = c(0, 1.9), type = "n", xlab = "x", ylab = "y")
    grid()
    x = seq(0, 10, length = 501)
    lines(x, exp(-x)*BesselI(x, 0))
    lines(x, exp(-x)*BesselI(x, 1), lty = 3)
    lines(x, exp(x)*BesselK(x, 0))
    lines(x, exp(x)*BesselK(x, 1), lty = 3)
    
    # Abramowitz-Stegun, Figure 9.9, p. 375
    # Use R's internally implemented Bessel Functions ...
    plot(x = c(-10, 10), y = c(-5, 30), type = "n", xlab = "nu", ylab = "y")
    grid()
    nu = seq(-10, 10, length = 501)
    lines(nu, besselI(x = 5, nu))
    lines(nu, besselK(x = 5, nu), lty = 3)

    # Bessel I0 and K0
    
    # Abramowitz-Stegun: Table 9.8, p. 416-422
    x = c(0.0, 0.01, 0.1, 0.2, 0.5, 1, 2, 5, 10, 20, 50)  
    data.frame(x, I = exp(-x)*BesselI(x, 0), K = exp(x)*BesselK(x, 0)) 
    # Compare with R's internal function:
    data.frame(x, I = exp(-x)*besselI(x, 0), K = exp(x)*besselK(x, 0)) 
  
    # Bessel I2 and K2
    
    # Abramowitz-Stegun: Table 9.8, p. 416-422
    x = c(0.01, 0.1, 0.2, 0.5, 1, 2, 5, 10, 20, 50)  
    data.frame(x, I = BesselI(x, 2)/x^2, K = BesselK(x, 2)*x^2) 
    # Compare with R's internal function:
    data.frame(x, I = besselI(x, 2)/x^2, K = besselK(x, 2)*x^2)
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.BesselAssociatedSeries = 
function()
{   
    # Associated Hyperbolic Series, Abramowitz-Stegun 9.6.39, p. 376
    besselI(x = 1, 0) + 2 * sum((-1)^(1:10)*besselI(x = 1, 2*(1:10)))
    1
    
    # Associated Hyperbolic Series, Abramowitz-Stegun 9.6.39, p. 376
    besselI(x = 1, 0) + 2 * sum(besselI(x = 1, 1:20))
    exp(1)
    
    # Associated Hyperbolic Series, Abramowitz-Stegun 9.6.39, p. 376
    besselI(x = 1, 0) + 2 * sum((-1)^(1:20)*besselI(x = 1, 1:20))
    exp(-1)  
    
    # Associated Hyperbolic Series, Abramowitz-Stegun 9.6.39, p. 376
    besselI(x = 1, 0) + 2 * sum(besselI(x = 1, 2*(1:10)))
    cosh(1)
    
    # Associated Hyperbolic Series, Abramowitz-Stegun 9.6.40, p. 376
    2* sum(besselI(x = 1, 2*(0:10)+1))
    sinh(1)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.BesselD = 
function()
{
    # BesselDI - Derivative of BesselI
    # BesselDK - Derivative of BesselK

    # Check:
    # I0'(x) = I1(x)
    x = c(0.01, 0.1, 0.2, 0.5, 1, 2, 5, 10, 20, 50)
    BesselDI(x, 0) / BesselI(x, 1)
    
    # Check:
    # K0'(x) = -K1(x)
    x = c(0.01, 0.1, 0.2, 0.5, 1, 2, 5, 10, 20, 50)
    - BesselDK(x, 0) / BesselK(x, 1)

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


if (FALSE) {
    require(RUnit)
    testResult <- runTestFile("C:/Rmetrics/SVN/trunk/fOptions/tests/runit3D.R",
        rngKind = "Marsaglia-Multicarry", rngNormalKind = "Inversion")
    printTextProtocol(testResult)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:       DESCRIPTION:
#  erf             Error function
#  [gamma]         Gamma function 
#  [lgamma]        LogGamma function, returns log(gamma)
#  [digamma]       First derivative of of LogGamma, dlog(gamma(x))/dx
#  [trigamma]      Second derivative of of LogGamma, dlog(gamma(x))/dx
#  {tetragamma}    Third derivative of of LogGamma, dlog(gamma(x))/dx
#  {pentagamma}    Fourth derivative of LogGamma, dlog(gamma(x))/dx
#  [beta]*         Beta function
#  [lbeta]*        LogBeta function, returns log(Beta)
#  Psi             Psi(x) (Digamma) function
#  igamma          P(a,x) Incomplete Gamma Function
#  cgamma          Gamma function for complex arguments
#  Pochhammer      Pochhammer symbol
# NOTES:
#  Functions in [] paranthesis are part of the R's and SPlus' base distribution
#  Functions in {} paranthesis are only availalble in R
#  Function marked by []* are compute through the gamma function in SPlus
################################################################################


test.erf = 
function()
{
    # Error Function
    
    # erf(x) - Abramowitz-Stegun p. 310 ff
    erf(0.0)  
                     
    erf(0.5) - 0.5204998788   
    erf(1.0) - 0.8427007929
    erf(2.0) - 0.9953222650
    
    erf(-0.5) + 0.5204998788   
    erf(-1.0) + 0.8427007929
    erf(-2.0) + 0.9953222650
    
    x = seq(-5, 5, length = 101)
    y = erf(x)
    par(mfrow = c(1,1))
    plot(x, y, type = "b", pch = 19)

    # Symmetry Relation, p. 297
    # erf(-x) = - erf(x)
    erf(-0.5) + erf(0.5)
    erf(-pi)  + erf(pi)
    
    # Abramowitz-Stegun: Example 1, p. 304
    erf(0.745) - 0.707928920
  
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.erfc = 
function()
{
    # Complementary Error Function
    
    # Add functions:
    erfc = function(x) { 1 - erf(x) }
    erfc(0.5)
    erf(0.5) + erfc(0.5)
    
    # Abramowitz-Stegun: Example 2, p. 304
    1.1352e-11
    1 - erf(4.8)
  
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.gamma = 
function()
{
    # Gamma Function
    
    # Abramowitz-Stegun: Figure 6.1, p. 255
    x = seq(-4.01, 4.01, by = 0.011)
    
    # Plot:
    plot(x, gamma(x), ylim = c(-5,5), type = "l", main = "Gamma Function")
    grid()
    abline(h = 0, col = "red", lty = 3)
    for (i in c(-4:0)) abline(v = i, col = "white")
    for (i in c(-4:0)) abline(v = i, col = "red", lty = 3)
    
    # Add 1/Gamma:
    lines(x, 1/gamma(x), lty = 3)
  
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.Psi = 
function()
{    
    # Psi Function
    
    # Abramowitz-Stegun: Figure 6.2, p. 258
    x = seq(-4.01, 4.01, by = 0.011)
    plot(x, Psi(x), ylim = c(-5, 5), type = "l", main = "Psi Function")
    grid()
    abline(h = 0, col = "red", lty = 3)
    for (i in c(-4:0)) abline(v = i, col = "white")
    for (i in c(-4:0)) abline(v = i, col = "red", lty = 3)
  
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.incompleteGamma = 
function()
{        
    # Incomplete Gamma Function
    
    # Abramowitz-Stegun: Figure 6.3. 
    gammaStar = function(x, a) { igamma(x,a)/x^a }
    # ... create Figure as an exercise.

    # Abramowitz-Stegun: Formula 6.5.12
    # Relation to Confluent Hypergeometric Functions
    a = sqrt(2)
    x = pi
    Re ( (x^a/a) * kummerM(-x, a, 1+a) )
    Re ( (x^a*exp(-x)/a) * kummerM(x, 1, 1+a) )
    pgamma(x, a) * gamma(a)
    igamma(x, a)                                         
    
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.complexGamma = 
function()
{      
    # Complex Gamma Function
    
    # Abramowitz-Stegun: Tables 6.7, p. 277
    x = 1
    y = seq(0, 5, by = 1); x = rep(x, length = length(y))
    z = complex(real = x, imag = y)
    c = cgamma(z, log = TRUE)
    cbind(x, y, "Re ln" = Re(c), "Im ln" = Im(c))
    
    # Abramowitz-Stegun: Tables 6.7, p.287
    x = 2
    y = seq(0, 5, by = 1); x = rep(x, length = length(y))
    z = complex(real = x, imag = y)
    c = cgamma(z, log = TRUE)
    cbind(x, y, "Re ln" = Re(c), "Im ln" = Im(c))
    
    # cgamma -
    # Abramowitz-Stegun: Examples, p. 263
    options(digits = 10)
    # Example 1, 2
    gamma(6.38); lgamma(56.38)                            
    # 3, 4
    Psi(6.38); Psi(56.38)                                 
    # 5
    cgamma(complex(real = 1, imag = -1), log = TRUE )     
    # 6
    cgamma(complex(real = 1/2, imag = 1/2), log = TRUE )  
    # 7, 8
    cgamma(complex(real = 3, imag = 7), log = TRUE )       

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.Pochhammer = 
function()
{      
    # Pochhammer Symbol
    
    # Abramowitz-Stegun: Formula 6.1.22, p. 256
    
    # Pochhammer(x, n)
    Pochhammer(x = 1, n = 0) - 1
    Pochhammer(x = 1, n = 1) - 1
    Pochhammer(x = 2, n = 2) - gamma(2+2)/gamma(2)
        
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------

   
if (FALSE) {
    require(RUnit)
    testResult <- runTestFile("C:/Rmetrics/SVN/trunk/fOptions/tests/runit3B.R",
        rngKind = "Marsaglia-Multicarry", rngNormalKind = "Inversion")
    printTextProtocol(testResult)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:       KUMMER DESCRIPTION:               
#  kummerM         Computes Confluent Hypergeometric Function of the 1st Kind
#  kummerU         Computes Confluent Hypergeometric Function of the 2nd Kind
# FUNCTION:       WHITTAKER DESCRIPTION:
#  whittakerM      Computes Whittaker's M Function
#  whittakerW      Computes Whittaker's M Function
# FUNCTION:       HERMITE POLYNOMIAL:
#  hermiteH        Computes the Hermite Polynomial
################################################################################


test.kummer = 
function()
{
    # kummerM(x, a, b, lnchf = 0, ip = 0) 
    # kummerU(x, a, b, ip = 0)
    
    # Relation to Modified Bessel Function:
    # Abramowitz-Stegun: Formula 13.6.3, p. 509
    x = c(0.001, 0.01, 0.1, 1, 10, 100, 1000)  
    nu = 1; a = nu+1/2; b = 2*nu+1
    M = Re ( kummerM(x = 2*x, a = a, b = b) )
    Bessel = gamma(1+nu) * exp(x)*(x/2)^(-nu) * BesselI(x, nu)
    cbind(x, M, Bessel) 
    
    # Relation to Hyperbolic Function:
    # Abramowitz-Stegun: Formula 13.6.14, p. 509
    x = c(0.001, 0.01, 0.1, 1, 10, 100, 1000)  
    M = Re ( kummerM(2*x, a = 1, b = 2) )
    Sinh = exp(x)*sinh(x)/(x)
    cbind(x, M, Sinh)
    
    # Relation to Complex Hyperbolic Function:
    # Abramowitz-Stegun: Formula 13.6.14, p. 509
    y = rep(1, length = length(x))
    x = complex(real = x, imag = y)
    M = kummerM(2*x, a = 1, b = 2)
    Sinh = exp(x)*sinh(x)/(x)
    cbind(x, M, Sinh)
    
    # Abramowitz-Stegun: Examples, p. 511
    M = function(a, b, x) { Re (kummerM(x, a, b)) }     
    # Example 1
    M(  0.3,  0.2, -0.1)  - 0.8578490                       
    # 2
    M( 17.0, 16.0, 1)     - 2.8881744                       
    # 3
    M( -1.3,  1.2, 0.1)   - 0.8924108                      
    # 4
    # M( -1, -1.0, 0)     # undefined                   
    # 6
    M( 0.9,   0.1, 10)    - 1227235                       
    # 7
    M(-52.5,  0.1, 1)     - 16.34                                        # CHECK
    
    # Abramowitz-Stegun: Examples, p. 511
    U = function(a, b, x) { Re (kummerU(x, a, b)) }     
    # 9
    U( 1.1, 0.2, 1)     - 0.38664                           
    U(-0.9, 0.2, 1)     - 0.91272                         
    # 10
    U( 0.1, 0.2, 1)*0.9 - 0.85276                            
    # 11
    U( 1.0, 0.1, 100)   - 0.0098153                                      # CHECK
    # 12
    U( 0.1, 0.2, 0.01)  - 1.09                        
    
    # Abramowitz-Stegun: Example 17, Figure 13.2, p. 513
    # M(-4.5, 1, x)
    x = seq(0, 17, length = 200)
    plot(x = x, y = kummerM(x, -4.5, 1), type = "l", ylim = c(-25,125),
        main = "Figure 13.2:  M(-4.5, 1, x)")
    lines(x = c(0, 16), y = c(0, 0), col = 2)
    
    # Abramowitz-Stegun: Example 17, Figure 13.3, p. 513
    # M(a, 1, x)
    x = seq(0, 8, length = 200)
    plot(x = c(0, 8), y = c(-10, 10), type = "n", 
        main = "Figure 13.2:  M(-4.5, 1, x)")
    grid()
    for (a in seq(-4, 0, by = 0.5))
        lines(x = x, y = kummerM(x, a, 1), type = "l")
    abline(h = 0, lty = 3, col = "red")
    
    # Abramowitz-Stegun: Example 17, Figure 13.4, p. 513
    # M(a, 0.5, x)
    x = seq(0, 7, length = 200)
    plot(x = c(0, 7), y = c(-10, 15), type = "n", 
        main = "Figure 13.2:  M(-4.5, 1, x)")
    grid()
    for (a in seq(-4, 0, by = 0.5))
        lines(x = x, y = kummerM(x, a, 0.5), type = "l")
    abline(h = 0, lty = 3, col = "red")
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.whittaker = 
function()
{
    # whittakerM(x, kappa, mu, ip = 0) 
    # whittakerW(x, kappa, mu, ip = 0)
     
    # Abramowitz-Stegun: Example 13
    AS = c(1.10622, 0.57469)
    W = c(
     whittakerM(x = 1, kappa = 0, mu = -0.4),
     whittakerW(x = 1, kappa = 0, mu = -0.4) )
    data.frame(AS, W)

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hermite = 
function()
{
    # Hermite Polynomial - internally computed from Kummer U
    
    # hermiteH(x, n, ip = 0)

    # http://mathworld.wolfram.com/HermitePolynomial.html
    x = seq(-2, 2, length = 401)
    par(mfrow = c(1, 1))
    plot(x = c(-2,2), y = c(-30, 30), type = "n", main = "Hermite Polynomials")
    grid()
    for (i in 1:4) lines(x, hermiteH(x, i), col = i)
    
    # Test H4:
    H4 = function(x) { 16*x^4 -48*x^2 + 12 }
    x = -5:5
    cbind(x, hermite = hermiteH(x, 4), H = H4(x))
    
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


if (FALSE) {
    require(RUnit)
    testResult <- runTestFile("C:/Rmetrics/SVN/trunk/fOptions/tests/runit3C.R",
        rngKind = "Marsaglia-Multicarry", rngNormalKind = "Inversion")
    printTextProtocol(testResult)
}


################################################################################
